/*▄▄▄    ███▄ ▄███▓  ▄████  ▄▄▄██▀▀▀▓█████▄▄▄█████▓
▓█████▄ ▓██▒▀█▀ ██▒ ██▒ ▀█▒   ▒██   ▓█   ▀▓  ██▒ ▓▒
▒██▒ ▄██▓██    ▓██░▒██░▄▄▄░   ░██   ▒███  ▒ ▓██░ ▒░
▒██░█▀  ▒██    ▒██ ░▓█  ██▓▓██▄██▓  ▒▓█  ▄░ ▓██▓ ░ 
░▓█  ▀█▓▒██▒   ░██▒░▒▓███▀▒ ▓███▒   ░▒████▒ ▒██▒ ░ 
░▒▓███▀▒░ ▒░   ░  ░ ░▒   ▒  ▒▓▒▒░   ░░ ▒░ ░ ▒ ░░*/
using HarmonyLib;
using Oxide.Core.Plugins;
using System;
namespace Oxide.Plugins
{
    [Info("AlwaysHotSpot", "bmgjet", "1.0.0")]
    class AlwaysHotSpot : RustPlugin
    {
        [AutoPatch]
        [HarmonyPatch(typeof(TreeEntity), "DidHitMarker", new Type[] { typeof(HitInfo) })]
        internal class TreeEntity_DidHitMarker
        {
            [HarmonyPrefix]
            private static bool Prefix(HitInfo info, ref bool __result)
            {
                try
                {
                    if (info != null)
                    {
                        __result = true;
                        return false;
                    }
                }
                catch { }
                return true;
            }
        }

        [AutoPatch]
        [HarmonyPatch(typeof(OreResourceEntity), "OnAttacked", new Type[] { typeof(HitInfo) })]
        internal class OreResourceEntity_OnAttacked
        {
            [HarmonyPrefix]
            private static bool Prefix(HitInfo info, OreResourceEntity __instance)
            {
                try
                {
                    if (info != null && __instance != null)
                    {
                        if (__instance._hotSpot == null)
                        {
                            __instance._hotSpot = __instance.SpawnBonusSpot(info.HitPositionWorld);
                        }
                        __instance._hotSpot.transform.position = info.HitPositionWorld;
                        __instance._hotSpot.SendNetworkUpdateImmediate(false);
                    }
                }
                catch { }
                return true;
            }
        }
    }
}